from gbso.cpu.insn import *
from gbso.cpu.regs import R8, R16

from gbso.optimize import optimize
from gbso.program.program import Program

rLCDC = 0xFF40
rIE = 0xFFFF

IEF_VBLANK = 1 << 0

prgm = Program(
    insns=[
        LD_R_N8(R8.A, 12),
        LD_RR_NN(R16.HL, rLCDC),
        RES_N_HL(7),
        RES_N_HL(2),
        LD_RR_NN(R16.HL, rIE),
        LD_HL_N(IEF_VBLANK),
    ],
)

optimized_prgm = optimize(prgm)
optimized_prgm.display()
